



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JAVA核心技术I---JAVA基础知识（列表List）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JAVA核心技术I---JAVA基础知识（列表List）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 06:11:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>一：List了解</h1>
<h2>（一）List：列表</h2>
<div>
<pre class="prettyprint linenums">&ndash;有序的Collection<br />
&ndash;允许重复元素<br />
&ndash;{，，，{，}，，}</pre>
</div>
<h2>（二）List：主要实现</h2>
<h3>同步/非同步：针对线程而言</h3>
<div>
<pre class="prettyprint linenums">&ndash;ArrayList(非同步的)<br />
&ndash;LinkedList(非同步)<br />
&ndash;Vector(同步)　　</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1309518/201901/1309518-20190104105505387-1092813207.png" /></p>
<h1>二：ArrayList：数组实现</h1>
<h2>（一）ArrayList了解</h2>
<div>
<pre class="prettyprint linenums">&ndash;以数组实现的列表，不支持同步<br />
    List list = Collections.synchronizedList(new ArrayList(...));<br />
&ndash;利用索引位置可以快速定位访问&ndash;不适合指定位置的插入、删除操作<br />
&ndash;适合变动不大，主要用于查询的数据<br />
&ndash;和Java数组相比，其容量是可动态调整的<br />
&ndash;ArrayList在元素填满容器时会自动扩充容器大小的50%</pre>
</div>
<h2>（二）ArrayList实现</h2>
<div>
<pre class="prettyprint linenums">        ArrayList&lt;Integer&gt; al = new ArrayList&lt;Integer&gt;();    //&lt;&gt;是泛型编程，类似于C++模板<br />
        al.add();<br />
        al.add();<br />
        al.add();<br />
        al.add();<br />
        al.add();<br />
        al.add(new Integer());

        System.out.println("the third elem:"+al.get());    //从0开始索引<br />
        al.remove();    //删除第四个元素<br />
        al.add(, );     //插入第四个元素为10</pre>
</div>
<div>
<pre class="prettyprint linenums">        //进行遍历<br />
        trverseByIterator(al);<br />
        trverseByIndex(al);<br />
        trverseByFor(al);</pre>
</div>
<div>
<pre class="prettyprint linenums">
    public static void trverseByIterator(ArrayList&lt;Integer&gt; al) {<br />
        //使用迭代器遍历<br />
        System.out.println("==========迭代器遍历===========");<br />
        long startTime = <strong>System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。 </strong><br />
        Iterator&lt;Integer&gt; iter = al.iterator();    //获取迭代指针<br />
        while(iter.hasNext()) {<br />
            System.out.print(<strong>iter.next()</strong>);　　//<strong>指针会下移，但是会先返回当前指针指向的数据值</strong><br />
        }<br />
        long endTime = System.nanoTime();<br />
        long duration = endTime-startTime;<br />
        System.out.println("iterator使用纳秒："+duration);<br />
    }

    public static void trverseByIndex(ArrayList&lt;Integer&gt; al) {<br />
        //使用迭代器遍历<br />
        System.out.println("==========index索引遍历===========");<br />
        long startTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        for(int i=;i&lt;al.size();i++) {<br />
            System.out.print(al.get(i));<br />
        }<br />
        long endTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        long duration = endTime-startTime;<br />
        System.out.println("index使用纳秒："+duration);<br />
    }

    public static void trverseByFor(ArrayList&lt;Integer&gt; al) {<br />
        //使用迭代器遍历<br />
        System.out.println("==========for索引遍历===========");<br />
        long startTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        for(Integer item : al) {<br />
            System.out.print(item);<br />
        }<br />
        long endTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        long duration = endTime-startTime;<br />
        System.out.println("for使用纳秒："+duration);<br />
    }</pre>
</div>
<div>
<div>
<pre class="prettyprint linenums">==========迭代器遍历===========<br />
3121066iterator使用纳秒：<br />
==========index索引遍历===========<br />
3121066index使用纳秒：<br />
==========for索引遍历===========<br />
3121066for使用纳秒：</pre>
</div>
<p>输出</p></div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1309518/201901/1309518-20190104104101155-40596289.png" /></p>
<h2>（三）性能测试：索引效率高</h2>
<div>
<pre class="prettyprint linenums">        for(int i=;i&lt;;i++) {<br />
            al.add(i);<br />
        }</pre>
</div>
<div>
<pre class="prettyprint linenums">==========迭代器遍历===========<br />
iterator使用纳秒：<br />
==========index索引遍历===========<br />
index使用纳秒：<br />
==========for索引遍历===========<br />
for使用纳秒：</pre>
</div>
<h1>三：LinkedList：链表实现</h1>
<h2>（一）LinkedList了解</h2>
<div>
<pre class="prettyprint linenums">&ndash;以双向链表实现的列表，不支持同步<br />
    List list = Collections.synchronizedList(new LinkedList(...));<br />
&ndash;可被当作堆栈、队列和双端队列进行操作<br />
&ndash;顺序访问高效，随机访问较差，中间插入和删除高效<br />
&ndash;适用于经常变化的数</pre>
</div>
<h2>（二）LinkedList实现</h2>
<div>
<pre class="prettyprint linenums">public class LinkedListTest {<br />
    public static void main(String[] args) {<br />
        LinkedList&lt;Integer&gt; ll = new LinkedList&lt;Integer&gt;();    //&lt;&gt;是泛型编程，类似于C++模板

        /*for(int i=0;i&lt;10000;i++) {<br />
            ll.add(i);<br />
        }<br />
        */

        ll.add();<br />
        ll.add();<br />
        ll.add();<br />
        ll.add();<br />
        ll.add();<br />
        ll.add(new Integer());

        System.out.println("the third elem:"+ll.get());    //从0开始索引<br />
        ll.remove();    //删除第四个元素<br />
        ll.add(, );     //插入第四个元素为10

        //进行遍历<br />
        trverseByIterator(ll);<br />
        trverseByIndex(ll);<br />
        trverseByFor(ll);<br />
    }

    public static void trverseByIterator(LinkedList&lt;Integer&gt; ll) {<br />
        //使用迭代器遍历<br />
        System.out.println("==========迭代器遍历===========");<br />
        long startTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        Iterator&lt;Integer&gt; iter = ll.iterator();    //获取迭代指针<br />
        while(iter.hasNext()) {<br />
            System.out.print(iter.next());<br />
        }<br />
        long endTime = System.nanoTime();<br />
        long duration = endTime-startTime;<br />
        System.out.println("iterator使用纳秒："+duration);<br />
    }

    public static void trverseByIndex(LinkedList&lt;Integer&gt; ll) {<br />
        //使用迭代器遍历<br />
        System.out.println("==========index索引遍历===========");<br />
        long startTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        for(int i=;i&lt;ll.size();i++) {<br />
            System.out.print(ll.get(i));<br />
        }<br />
        long endTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        long duration = endTime-startTime;<br />
        System.out.println("index使用纳秒："+duration);<br />
    }

    public static void trverseByFor(LinkedList&lt;Integer&gt; ll) {<br />
        //使用迭代器遍历<br />
        System.out.println("==========for索引遍历===========");<br />
        long startTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        for(Integer item : ll) {<br />
            System.out.print(item);<br />
        }<br />
        long endTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        long duration = endTime-startTime;<br />
        System.out.println("for使用纳秒："+duration);<br />
    }<br />
}</pre>
</div>
<div>
<div>
<pre class="prettyprint linenums">==========迭代器遍历===========<br />
3121066iterator使用纳秒：<br />
==========index索引遍历===========<br />
3121066index使用纳秒：<br />
==========for索引遍历===========<br />
3121066for使用纳秒：</pre>
</div>
<p>输出</p></div>
<h2>（三）性能测试：for遍历效率高</h2>
<div>
<pre class="prettyprint linenums">==========迭代器遍历===========<br />
iterator使用纳秒：<br />
==========index索引遍历===========<br />
index使用纳秒：<br />
==========for索引遍历===========<br />
for使用纳秒：</pre>
</div>
<h1>四：vector向量（同步）</h1>
<h2>（一）vector了解</h2>
<div>
<pre class="prettyprint linenums">&ndash;和ArrayList类似，可变数组实现的列表<br />
&ndash;Vector同步，适合在多线程下使用<br />
&ndash;原先不属于JCF框架，属于Java最早的数据结构，性能较差<br />
&ndash;从JDK1.2开始，Vector被重写，并纳入到JCF<br />
&ndash;官方文档建议在非同步情况下，优先采用ArrayList</pre>
</div>
<h2>（二）vector实现</h2>
<div>
<div>
<pre class="prettyprint linenums">import java.util.Vector;<br />
import java.util.Iterator;

public class vectorTest {<br />
    public static void main(String[] args) {<br />
        Vector&lt;Integer&gt; v = new Vector&lt;Integer&gt;();    //&lt;&gt;是泛型编程，类似于C++模板

        for(int i=;i&lt;;i++) {<br />
            v.add(i);<br />
        }

        //进行遍历<br />
        trverseByIterator(v);<br />
        trverseByIndex(v);<br />
        trverseByFor(v);<br />
    }

    public static void trverseByIterator(Vector&lt;Integer&gt; v) {<br />
        //使用迭代器遍历<br />
        System.out.println("==========迭代器遍历===========");<br />
        long startTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        Iterator&lt;Integer&gt; iter = v.iterator();    //获取迭代指针<br />
        while(iter.hasNext()) {<br />
            iter.next();<br />
        }<br />
        long endTime = System.nanoTime();<br />
        long duration = endTime-startTime;<br />
        System.out.println("iterator使用纳秒："+duration);<br />
    }

    public static void trverseByIndex(Vector&lt;Integer&gt; v) {<br />
        //使用迭代器遍历<br />
        System.out.println("==========index索引遍历===========");<br />
        long startTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        for(int i=;i&lt;v.size();i++) {<br />
            v.get(i);<br />
        }<br />
        long endTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        long duration = endTime-startTime;<br />
        System.out.println("index使用纳秒："+duration);<br />
    }

    public static void trverseByFor(Vector&lt;Integer&gt; v) {<br />
        //使用迭代器遍历<br />
        System.out.println("==========for索引遍历===========");<br />
        long startTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        for(Integer item : v) {<br />
            ;<br />
        }<br />
        long endTime = System.nanoTime();    //获取开始时间，以纳秒为单位返回正在运行的Java虚拟机的高分辨率时间源的当前值。<br />
        long duration = endTime-startTime;<br />
        System.out.println("for使用纳秒："+duration);<br />
    }<br />
}</pre>
</div>
</div>
<h2>（三）性能测试：for效率好</h2>
<h1>五：总结</h1>
<h2>（一）ArrayList/LinkedList/Vector</h2>
<h2>（二）同步采用Vector</h2>
<h2>（三）非同步情况下，根据数据操作特点选取ArrayList/LinkedList</h2>
<h2>（四）ArrayList与LinkedList插入，查找性能比较</h2>
<div>
<pre class="prettyprint linenums">ArrayList查找效率高，LinkedList查找效率低。（修改同查找）<br />
ArrayList删除效率低，需要移动大量数据，LinkedList删除效率高，不需要移动数据。&lt;视情况而论，毕竟LinkedList会先进行查找操作&gt;</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390rndm9.html">2014年百度之星程序设计大赛 - 初赛（第二轮）Chess</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvexox9.html">ubuntu中 不同JDK版本之间的切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxl5peq.html">PHP学习-链接数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyrxem8.html">EF6 CodeFirst&plus;Repository&plus;Ninject&plus;MVC4&plus;EasyUI实践&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2lk1w9.html">javascript复习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m5x46q.html">iOS9支付完成无法获取回调</a>
		</li>
						<li><a href="https://www.batexi.com/a/495opr08.html">Leetcode 290 Word Pattern STL</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq11n36q.html">iOS开发笔记10&colon;圆点缩放动画、强制更新、远程推送加语音提醒及UIView截屏</a>
		</li>
						<li><a href="https://www.batexi.com/a/r935oywq.html">spring mvc实现新增用户</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmepdz9.html">关于Warn&colon;name or service not known的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z14nl39.html">Java API &mdash;&mdash; IO流小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y7xz3q.html">（转）&lbrack;C&plus;&plus;语法&rsqb; 关键字typedef用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy11xpxq.html">微通道产品经理Grover采访：美国的微通道设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p0w738.html">json在线编辑器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxklwnv8.html">评测：VPS推荐digitalocean和Vultr和Linode</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy12ep2q.html">UESTC 1222 Sudoku</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg7rg48.html">&period;net 设置webbrowser控件使用的IE版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zvnwx9.html">Beta No&period;7</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gey5rl8.html">全局变量&amp;amp&semi;局部变量&comma;global&amp;amp&semi;nonlocal</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mg7rm8.html">asp&period;net Core HttpClient 出现Cannot access a disposed object&period; Object name&colon; &amp;&num;39&semi;SocketsHttpHandler&amp;&num;39&semi; 的问题。</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gp1yzq.html">一个模拟&mdash;&mdash;抢票部分功能的 简单版（主要实例化一下 Lock 的使用）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvomkz8.html">robotframework测试用例加入注释</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rdxv39.html">GCD HDU - 1695 （欧拉 &plus; 容斥）</a>
			</li>
						<li><a href="https://www.batexi.com/a/960mw039.html">Marriage Match III HDU - 3277（二分权值 &plus; 拆点 建边）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wj4dzq.html">pytorch CNN 手写数字识别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e40grm9.html">MT【252】椭圆内接三角形内切圆半径</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj3wm09.html">洛谷P4689 &lbrack;Ynoi2016&rsqb;这是我自己的发明（莫队，树的dfn序，map，容斥原理）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25x40vq.html">搜索引擎（Elasticsearch搜索详解）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllo4x6q.html">OpenDCIM-19&period;01操作手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwmr5y8.html">Android客户端与数据库交互数据的简单学习</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
